=== examples/exception-injector/Makefile ===

injector.exe: injector.c
	gcc -O3 -s -Wall -Wextra -o$@ $^

clean:
	rm -f injector.exe
